﻿Imports System.Data
Imports SciLorsGroovesharkAPI


Public Class ResultGrid
    Public Id As Integer
    Public Artist As String
    Public Title As String
    Public Album As String
    Public Year As String
    Public Length As String
    Public Bitrate As String
    Public Popularity As String
    Public Result As Groove.Functions.SearchArtist.SearchArtistResult

    Sub New()

    End Sub

    Sub New(ByRef ResultSet As Groove.Functions.SearchArtist.SearchArtistResult)
        Result = ResultSet
        Reload()
    End Sub

    Public Sub Reload()
        Id = Result.SongID
        Artist = Result.ArtistName
        Title = Result.SongName
        Album = Result.AlbumName
        Year = Result.Year

        Dim Duration As Integer = 0
        Try
            Duration = Integer.Parse(Result.EstimateDuration) 'Math.Max(Result.EstimateDuration, Result.AvgDuration)
            Duration = Math.Max(Duration, Integer.Parse(Result.AvgDuration))
        Catch ex As Exception
        End Try

        If Duration > 0 Then
            Length = Format((Math.Floor(Duration / 60)), "00") & ":" & Format(Duration Mod 60, "00")
        Else
            Length = ""
        End If
        Bitrate = Result.BitRate

        Popularity = Result.Popularity
    End Sub

    Public Shared Function ReturnBaseTable(Optional ByVal Extended As Boolean = False) As DataTable
        Dim tempTable = New DataTable
        Dim tempCol As DataColumn


        If Extended Then
            tempCol = New DataColumn()
            With tempCol
                .DataType = Type.GetType("System.Boolean")
                .ColumnName = "Load"
                .ReadOnly = False
                tempTable.Columns.Add(tempCol)
            End With
        End If

        'tempCol = New DataColumn()
        'With tempCol
        '    .DataType = Type.GetType("System.Int32")
        '    .ColumnName = "Id"
        '    '.ReadOnly = True

        '    tempTable.Columns.Add(tempCol)
        'End With

        tempCol = New DataColumn()
        With tempCol
            .DataType = Type.GetType("System.String")
            .ColumnName = "Artist"
            .ReadOnly = True
            tempTable.Columns.Add(tempCol)
        End With

        tempCol = New DataColumn()
        With tempCol
            .DataType = Type.GetType("System.String")
            .ColumnName = "Title"
            .ReadOnly = True
            tempTable.Columns.Add(tempCol)
        End With

        tempCol = New DataColumn()
        With tempCol
            .DataType = Type.GetType("System.String")
            .ColumnName = "Album"
            .ReadOnly = True
            tempTable.Columns.Add(tempCol)
        End With

        tempCol = New DataColumn()
        With tempCol
            .DataType = Type.GetType("System.String")
            .ColumnName = "Year"
            .ReadOnly = True
            tempTable.Columns.Add(tempCol)
        End With

        tempCol = New DataColumn()
        With tempCol
            .DataType = Type.GetType("System.String")
            .ColumnName = "Length"
            .ReadOnly = True
            tempTable.Columns.Add(tempCol)
        End With

        tempCol = New DataColumn()
        With tempCol
            .DataType = Type.GetType("System.String")
            .ColumnName = "Bitrate"
            .ReadOnly = True
            tempTable.Columns.Add(tempCol)
        End With
        'tempCol = New DataColumn()
        'With tempCol
        '    .DataType = Type.GetType("System.String")
        '    .ColumnName = "Popularity"
        '    .ReadOnly = True
        '    tempTable.Columns.Add(tempCol)
        'End With

        Return tempTable
    End Function

    Public Shared Function CreateBaseTableRow(ByRef Table As DataTable, ByRef Data As ResultGrid) As DataRow
        Dim tempRow As DataRow = Table.NewRow()
        With Data
            'tempRow("Id") = .Id
            tempRow("Artist") = .Artist
            tempRow("Title") = .Title
            tempRow("Album") = .Album
            tempRow("Year") = .Year
            tempRow("Length") = .Length
            tempRow("Bitrate") = .Bitrate
            'tempRow("Popularity") = .Popularity
        End With
        Return tempRow
    End Function

    Public Overrides Function Equals(ByVal obj As Object) As Boolean
        If Not TypeOf obj Is ResultGrid Then
            Return False
        End If

        Dim tempGrid As ResultGrid = DirectCast(obj, ResultGrid)
        If Not tempGrid.Id = Me.Id Then
            Return False
        End If
        Return True
    End Function

End Class