﻿Imports System.Threading
Imports System.IO

Module MyStartUp
    Public mainWindow As MainWindow
    Public Function StartUp(ByVal window As MainWindow) As Boolean
        Try
            Dim fp As String = Path.Combine(GetAppPath(), "access")
            If File.Exists(fp) Then
                File.Delete(fp)
            End If
            File.WriteAllLines(fp, New String() {"access"})
            If Not File.Exists(fp) Then
                AdministrationRightsNeeded(False)
                Return False
            End If

            mainWindow = window
            Utilities.myConfig = New Settings
            If myConfig.Settings.AutoCheckUpdates = True Then
                Dim UpdateThread As New Thread(AddressOf UpdateCheck)
                UpdateThread.Start()
            End If
        Catch ex As UnauthorizedAccessException
            AdministrationRightsNeeded(False)
            Return False
        End Try
        Return True
    End Function

    Public Sub UpdateCheck(Optional ShowMessageWhenNoUpdate As Boolean = False)
        Dim UpdateChecker As New SciLors_UpdateCheck.SciLorsUpdateCheck()
        Dim tempCheck As String = UpdateChecker.checkVersion(myProgram.name, myProgram.longname, myProgram.version)

        If ShowMessageWhenNoUpdate Or UpdateChecker.LastCheckPositive Then
            MsgBox(tempCheck, MsgBoxStyle.OkOnly, "Update Check")
        End If
        If UpdateChecker.LastCheckPositive Then Return

        Dim API As New SciLorsGroovesharkAPI.Groove.GroovesharkClient(True)
        If API.UpdateGrooveFix() Then
            Call mainWindow.setGrooveClient(True)
            Call mainWindow.mniReconnect_Click(Nothing, Nothing)
        End If

    End Sub
End Module

Module myProgram
    Public version As String = "v0.4.13"
        Public name As String = "grooveshark-downloader"
        Public longname As String = "SciLor's grooveshark(tm).com Downloader"
    End Module